function cube = l1l1_resection_refine_bounds(cube,opts);
%tic;
% this is the multiple linear program version
H =cube.H;
Hnew=H;
cube.H = [];
cube.feasible = 0;

ii=1:opts.n;

if opts.branch_type == 1;
  ia=ii(opts.branch_array);
  ib=ii(~opts.branch_array);
  ib(1) = []; % ignore the first non-branching dimension

else
  lb=zeros(opts.n,1);
  bdcount = size(opts.StructureArray,2);
  if opts.n < bdcount 
    lb(1:opts.n)=1;
  else
    if cube.bdim
      lb(cube.bdim) = 1;
    end
    
    lb(2:bdcount) = 1;
    if (sum(lb)) < bdcount ;
      lb(bdcount+1) = 1;
    end
  end;

  lb = logical(lb);
  ia = ii(lb);
  ib = ii(~lb);
  ib(1) = [];
end;

if length(ib) == 0;
  cube.H = Hnew;
  cube.feasible =1;
  cube.refined = 1;
  return;
end


A = zeros(2*length(ia),opts.dim2);
c = zeros(2*length(ia),1);

A(1:length(ia),1:end-1)   = opts.StructureArray(ia,:);
A(1:length(ia),opts.dim2) = 1;
c(1:length(ia),1) = H(ia,2);

A(1+length(ia):end,1:end-1) = -opts.StructureArray(ia,:);
A(1+length(ia):end,opts.dim2) = -1;
c(1+length(ia):end,1) = -H(ia,1);

%fprintf('(');

Aeq = sparse([opts.StructureArray(1,:) 1]); 
ceq = 1;
A = sparse(A);
c = sparse(c);

lpoptions = opts.lpoptions;



for k = 1:length(ib);
    
    b=sparse([opts.StructureArray(ib(k),:) 1]);
    
    %minimize
    [x1,fval1,exitflag1,output1,lambda1]=linprog( b,A,c,Aeq,ceq,[],[],[],lpoptions);
    [x2,fval2,exitflag2,output2,lambda2]=linprog(-b,A,c,Aeq,ceq,[],[],[],lpoptions);
    fval2=-fval2;
    
    if (exitflag1==1)&(exitflag2==1);
        Hnew(ib(k),:)=[max(1e-10,fval1),max(1e-10,fval2)];
    elseif (exitflag1==-2)&(exitflag2==-2);
        Hnew=[];
        return;
    else
        fprintf('error : %d %d\n', exitflag1, exitflag2);
        output1
        output2
        
        Hnew=[];
        return;
    end

    if Hnew(ib(k),1) > Hnew(ib(k),2);
        fprintf('\nviolated %d %d %d\n',ib(k),Hnew(ib(k),1),Hnew(ib(k),2));
        keyboard;
    end;

end

Hnew=[max(H(:,1),Hnew(:,1)) min(H(:,2),Hnew(:,2))];

cube.H = Hnew;
cube.feasible =1;
cube.refined = 1;
