function cube = l1l1_triangle_refine_bounds(cube,opts);

% this is the multiple linear program version
H = cube.H;
Hnew=H;
cube.H=[];
cube.feasible=0;


ii=1:opts.n;
if opts.branch_type ==1;
  %fprintf('old branching\n');
  ia=ii(opts.branch_array);
  ib=ii(~opts.branch_array);
else
  lb=zeros(opts.n,1);
  if (opts.n < 3);
    lb(1:2) = 1;
  else
    if cube.bdim
      lb(cube.bdim) = 1;
    end
    
    lb(1:2) = 1;
    if (sum(lb)) < 3;
      lb(3) = 1;
    end
  end;
  lb = logical(lb);
  ia = ii(lb);
  ib = ii(~lb);
end;


  
if length(ib) == 0;
  cube.H = Hnew;
  cube.feasible = 1;
  cube.refined = 1;
  return;
end

A = zeros(2*length(ia),3);
c = zeros(2*length(ia),1);


A(1:length(ia),:) = squeeze(opts.Q(ia,3,1:3));
c(1:length(ia),1) = -squeeze(opts.Q(ia,3,4))+H(ia,2);
A(1+length(ia):end,:) = -squeeze(opts.Q(ia,3,1:3));
c(1+length(ia):end,1) = squeeze(opts.Q(ia,3,4))-H(ia,1);


for k = 1:length(ib);

    b=squeeze(opts.Q(ib(k),3,1:3));
    [x1,fval1,exitflag1,output1,lambda1]=linprog(b,A,c,[],[],[],[],[],opts.lpoptions);
    [x2,fval2,exitflag2,output2,lambda2]=linprog(-b,A,c,[],[],[],[],[],opts.lpoptions);

    fval1= squeeze(opts.Q(ib(k),3,1:3))'*x1+opts.Q(ib(k),3,4);
    fval2= squeeze(opts.Q(ib(k),3,1:3))'*x2+opts.Q(ib(k),3,4);

    if (exitflag1==1)&(exitflag2==1);

        Hnew(ib(k),:)=[fval1,fval2];

    else
      fprintf('refine error : %d %d\n', exitflag1, exitflag2);
      %output1
      %output2
      
      Hnew=[];
      return;
    end

end

Hnew=[max(H(:,1),Hnew(:,1)) min(H(:,2),Hnew(:,2))];
cube.H = Hnew;
cube.feasible = 1;
cube.refined = 1;

