function [outrect] = propagate_bound_triang(inrect, index, camlist, nbrimages);

%inrect = inrect1old;
%index = index2;

[m,n] = size(camlist{1});

if (index > n)
    conset = [1:n-1, index];
    remset = [n:index-1, index+1:nbrimages];
else
    conset = [1:n];
    remset = [n+1:nbrimages];
end

for i = 1:n
camP = camlist{conset(i)};
Amax(i,:) = -camP(m,:);
bmax(i,1) = -inrect.sllist(conset(i));
end

for i = 1:n
camP = camlist{conset(i)};
Amin(i,:) = camP(m,:);
bmin(i,1) = inrect.sulist(conset(i));
end

A = [Amax;Amin];
b = [bmax;bmin];

options = optimset('Display','off');
options = optimset(options,'LargeScale','off');

for i = 1:length(remset)
    camP = camlist{remset(i)};
    f = camP(m, :)';
    g = -f;
    [xtmp,lsolset(i),exitflag1] = linprog(f, A, b,[],[],[],[],[],options);
    [xtmp,usolset(i),exitflag2] = linprog(g, A, b,[],[],[],[],[],options);
end

if exitflag1 ~= 1
disp('Error propagating lower bounds. Setting to minus infinity.');
lsolset = -Inf*ones(size(remset));
end

if exitflag2 ~= 1
disp('Error propagating upper bounds. Setting to infinity.')
usolset = Inf*ones(size(remset));
end

outrect = inrect;
outrect.sllist(conset) = inrect.sllist(conset);
outrect.sllist(remset) = lsolset;
outrect.sulist(conset) = inrect.sulist(conset);
outrect.sulist(remset) = -usolset;

%outrect
%inrect

lretainlist = inrect.sllist;
lindretain = find(outrect.sllist > inrect.sllist);
lretainlist(lindretain) = outrect.sllist(lindretain);

uretainlist = inrect.sulist;
uindretain = find(outrect.sulist < inrect.sulist);
uretainlist(uindretain) = outrect.sulist(uindretain);

outrect.sllist = lretainlist;
outrect.sulist = uretainlist;

%%if length(lindretain) > 0
%fprintf('Lower bound propagated: %d :  ', length(lindretain))
%fprintf('%d  ', lindretain);
%fprintf('\n');
%%end

%%if length(uindretain) > 0
%fprintf('Upper bound propagated: %d :  ', length(uindretain))
%fprintf('%d  ', uindretain);
%fprintf('\n\n');
%%end


